;;; obsidian-config.el -*- lexical-binding: t; -*-

;; configure obsidian integration for note taking fun times
(use-package! obsidian
  :config
  (obsidian-specify-path "~/Library/Mobile Documents/iCloud~md~obsidian/Documents/Primary/")
  (setq obsidian-inbox-directory "_Inbox")
  (global-obsidian-mode t)
  (map! :map obsidian-mode-map
        "C-c C-o" #'obsidian-follow-link-at-point
        "C-c C-b" #'obsidian-backlink-jump
        "C-c C-l" #'obsidian-insert-wikilink)

  ;; custom quick capture template for obsidian daily note
  (defun mnl/obsidian-capture ()
    "Create new obsidian note. In the `obsidian-inbox-directory' if set otherwise in `obsidian-directory' root."
    (interactive)
    (let* ((title (read-from-minibuffer "Title: " (format-time-string "%Y-%m-%d")))
           (filename (s-concat obsidian-directory "/_Journal/" title ".md"))
           (clean-filename (s-replace "//" "/" filename)))
      (find-file (expand-file-name clean-filename) t)))

  (map! :leader
        :desc "Obsidian Quick Capture"
        "X" #'mnl/obsidian-capture)

  (map! :leader
        :prefix "n"
        :desc "Jump" "f" #'obsidian-jump
        :desc "Search" "s" #'obsidian-search
        :desc "Tag Search" "m" #'obsidian-tag-find
        :desc "Daily Note" "n" #'mnl/obsidian-capture
        :desc "Insert Wikilink" "w" #'obsidian-insert-wikilink
        :desc "Backlink Jump" "j" #'obsidian-backlink-jump
        :desc "Follow Link" "l" #'obsidian-follow-link-at-point
        :desc "Update" "u" #'obsidian-update
        "a" nil
        "d" nil))
